//
//  ZplatPlatformDelegate.h
//  Zplay_Demo
//
//  Created by Liubin on 2017/1/13.
//  Copyright © 2017年 ZPLAY. All rights reserved.
//

#import <Foundation/Foundation.h>
#import <UIKit/UIKit.h>

typedef enum : NSUInteger {
    
    //facebook
    ZplayFacebookPlatform           =       1,
    
    //wechat
    ZplayWeChatPlatform             =       2,
    
    //qq
    ZplayQQPlatform                 =       3,
    
    //游客
    ZplayVisitor                    =       4,

    
} ZplayPlatformType;


typedef enum {
    /**
     *  Platform Login Failed 登录失败
     */
    ZplayPlatformLoginFailed                        =       1001,
    /**
     *  Platform Binding Failed 绑定失败
     */
    ZplayPlatformConversionFailed                   =       1002,
    /**
     *  游客未进行实名制认证
     */
    ZplayPlatformVisitorNoAuthenticationID          =       1003,
    /**
     *  Pay Failed支付失败
     */
    ZplayPlatformPayFailed                          =       1004,
    /**
     *  Facebook Invite Friends Failed 邀请好友失败
     */
    ZplayPlatformInviteFriendsFailed                =       1005,
    /**
     *  init Parameter error参数错误
     */
    ZplayPlatformParameterError                     =       1006,
    /**
     *  正式用户实名认证失败
     */
    ZplayPlatformUserAuthenticationIDFailed         =       1007,
   
   
    
}ZplayPlatformFailed;


@protocol ZplatPlatformDelegate <NSObject>

/**
 *  开发者设置的ViewController
 *
 */
-(UIViewController*)viewControllerZplayLoginModalView;

/**
 失败

 @param errcode 错误码
 */
- (void)platformFailed:(ZplayPlatformFailed)errcode;


/**
 登录成功

 @param info 用户信息
 @param platform 登录的平台
 */
- (void)platformLoginSuccessWithUserInfo:(NSString *)info platform:(ZplayPlatformType)platform;


/**
 绑定成功

 @param info 用户信息
 @param platform 绑定的平台
 */
- (void)platformBindingSuccessWithUserInfo:(NSString *)info platform:(ZplayPlatformType)platform;


/**
 支付成功

 @param orderID 支付订单号
 */
- (void)zplayIAPSuccessWithPayOrderID:(NSString *)orderID;


/**
 查询计费点对应单位价格

 @param productPrice
 */
- (void)zplayReferCurrentProductIDWithPrice:(NSString *)productPrice;



/**
 获取Facebook好友资料，仅使用facebook登录和绑定的情况下会执行

 @param message 好友信息
 */
- (void)getFacebookUserFriendsMessage:(NSString *)message;



/**
 邀请Facebook好友成功
 
 @param message 
 */
- (void)inviteFacebookUserFriendsMessage:(NSString *)message;


/**
 获取微信是否安装

 @param installed YES已安装，NO未安装
 */
- (void)getWxIsInstalled:(BOOL)installed;


/**
 未成年玩家的游戏收益状态
 
 @param message 信息 verifystatus为"1"是成年用户，"2"是未成年用户
 */
- (void)zplayJuvenilesUserCurrentStatus:(NSString *)message;




@end
