//
//  ZplayQQLgoinAdapter.m
//  Zplay_Demo
//
//  Created by Liubin on 2017/3/10.
//  Copyright © 2017年 ZPLAY. All rights reserved.
//

#import "ZplayQQAccountLgoinAdapter.h"
#import <TencentOpenAPI/TencentOAuth.h>


@interface ZplayQQAccountLgoinAdapter()<TencentLoginDelegate,TencentSessionDelegate>
{
    TencentOAuth* _tencentOAuth;
    BOOL _isLogin;
}


@property (copy, nonatomic) NSString *access_token;
@property (copy, nonatomic) NSString *userid;

@property (copy, nonatomic) NSString *appID;


@end
@implementation ZplayQQAccountLgoinAdapter



+ (NSString *)loginType{
    return ZplayQQLoginAdapter;
}

+(void)load{
    [[ZplayLoginAdNetworkRegistry sharedRegistry]registerClass:self];
}

- (void)initializeLoginPlatforms{
    NSDictionary *plistDic = [[NSBundle mainBundle] infoDictionary];
    NSString *appid = [plistDic objectForKey:@"qqid"];
    self.appID = appid;
   
}


- (void)zplayPlatformLoginWithMessage:(id)message{
    
    _isLogin = YES;
    [self qqLogin];
    
}

- (void)zplayPlatformBindWithMessage:(id)message{
    _isLogin = NO;
    [self qqLogin];

}

- (void)qqLogin{
    _tencentOAuth = [[TencentOAuth alloc] initWithAppId:self.appID andDelegate:self];
    NSArray* permissions = [NSArray arrayWithObjects:
                            kOPEN_PERMISSION_GET_USER_INFO,
                            kOPEN_PERMISSION_GET_SIMPLE_USER_INFO,
                            kOPEN_PERMISSION_GET_INFO,
                            nil];
    
    // 这里调起登录
    [_tencentOAuth authorize:permissions inSafari:NO];
}

//登录成功：
- (void)tencentDidLogin
{
    if (_tencentOAuth.accessToken.length > 0 && _tencentOAuth.openId.length > 0) {
        
        self.access_token = _tencentOAuth.accessToken;
        self.userid = _tencentOAuth.openId;
        // 获取用户信息
        [_tencentOAuth getUserInfo];
        NSLog(@"登录成功：%@",_tencentOAuth.accessToken);
        
        
    } else {
        NSLog(@"登录不成功 没有获取accesstoken");
        if (_isLogin) {
            [self platfomrFailed:ZplayPlatformLoginFailed];
        }
        else{
            [self platfomrFailed:ZplayPlatformConversionFailed];
            
        }
    }
}

//非网络错误导致登录失败：
- (void)tencentDidNotLogin:(BOOL)cancelled {
    if (_isLogin) {
        [self platfomrFailed:ZplayPlatformLoginFailed];
    }
    else{
        [self platfomrFailed:ZplayPlatformConversionFailed];
        
    }
    if (cancelled) {
        NSLog(@"用户取消登录");
    } else {
        NSLog(@"登录失败");
    }
}

// 获取用户信息
- (void)getUserInfoResponse:(APIResponse *)response {
    if (response && response.retCode == URLREQUEST_SUCCEED) {
        
        /*
         {
         city = "";
         figureurl = "http://qzapp.qlogo.cn/qzapp/1000001089/6AF79FB38CBD3E224668A2E35F35C763/30";
         "figureurl_1" = "http://qzapp.qlogo.cn/qzapp/1000001089/6AF79FB38CBD3E224668A2E35F35C763/50";
         "figureurl_2" = "http://qzapp.qlogo.cn/qzapp/1000001089/6AF79FB38CBD3E224668A2E35F35C763/100";
         "figureurl_qq_1" = "http://q.qlogo.cn/qqapp/1000001089/6AF79FB38CBD3E224668A2E35F35C763/40";
         "figureurl_qq_2" = "http://q.qlogo.cn/qqapp/1000001089/6AF79FB38CBD3E224668A2E35F35C763/100";
         gender = "\U7537";
         "is_lost" = 0;
         "is_yellow_vip" = 0;
         "is_yellow_year_vip" = 0;
         level = 0;
         msg = "";
         nickname = "\U8bf7\U575a\U6301\U4e36\U9a9a\U5e74";
         province = "\U5317\U4eac";
         ret = 0;
         vip = 0;
         "yellow_vip_level" = 0;
         }
         */
        NSDictionary *userInfo = [response jsonResponse];
        NSString *nickName = userInfo[@"nickname"];
        NSString *headImageUrl = userInfo[@"figureurl_qq_2"];
        NSLog(@"qq用户信息：%@",userInfo);
        
        
        NSString *userHead = (NSString *)
        CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                                                  (CFStringRef)headImageUrl,
                                                                  NULL,
                                                                  (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                                  kCFStringEncodingUTF8));
        NSMutableDictionary *dict = [[NSMutableDictionary alloc]init];
        [dict setObject:self.userid==nil?@"":self.userid forKey:@"openid"];
        [dict setObject:self.access_token==nil?@"":self.access_token forKey:@"access_token"];
        [dict setObject:nickName==nil?@"":nickName forKey:@"nickname"];
        [dict setObject:userHead==nil?@"":userHead forKey:@"userHeadImage"];
        [dict setObject:[NSString stringWithFormat:@"%lu",(unsigned long)ZplayQQPlatform] forKey:@"platformType"];


        // 后续操作...
        if (_isLogin) {
            [self platfomrLoginSuccess:dict];
        }
        else{
            [self platformBindSucces:dict];
        }
        
    } else {
        NSLog(@"QQ auth fail ,getUserInfoResponse:%d", response.detailRetCode);
        [self platfomrFailed:ZplayPlatformLoginFailed];
    }
}

- (void)zplayPlatformLogout{
    [_tencentOAuth logout:self];

}

- (void)zplayLoginHandleOpenUrl:(id)platformMessage{
    if (platformMessage==nil) {
        return;
    }
    [TencentOAuth HandleOpenURL:[platformMessage objectForKey:@"url"]];

    
}

@end
