//
//  ZplayWeChatAccountLoginAdapter.m
//  Zplay_Demo
//
//  Created by Liubin on 2017/3/10.
//  Copyright © 2017年 ZPLAY. All rights reserved.
//

#import "ZplayWeChatAccountLoginAdapter.h"
#import "WXApi.h"
@interface ZplayWeChatAccountLoginAdapter()<WXApiDelegate>
{
    BOOL _isLogin;
}

@property (copy, nonatomic) NSString *code;
@property (copy, nonatomic) NSString *access_token;
@property (copy, nonatomic) NSString *openid;
@property (copy, nonatomic) NSString *weChtaAppId;
@property (copy, nonatomic) NSString *weChtaSecert;

@end

@implementation ZplayWeChatAccountLoginAdapter

+ (NSString *)loginType{
    return ZplayWeChatLoginAdapter;
}

+(void)load{
    [[ZplayLoginAdNetworkRegistry sharedRegistry]registerClass:self];
}


- (void)initializeLoginPlatforms{
    NSDictionary *plistDic = [[NSBundle mainBundle] infoDictionary];
    NSString *appid = [plistDic objectForKey:@"wechatid"];
    NSString *appSecert = [plistDic objectForKey:@"wesecertid"];
    self.weChtaAppId = appid;
    self.weChtaSecert = appSecert;
    [WXApi registerApp:appid];
    
    [[NSUserDefaults standardUserDefaults]setBool:[WXApi isWXAppInstalled] forKey:@"wxIsInstalled"];
}


- (void)zplayPlatformLoginWithMessage:(id)message{
    _isLogin = YES;
    [self wechatLogin];

}



- (void)zplayPlatformBindWithMessage:(id)message{
    _isLogin = NO;
    [self wechatLogin];
}

- (void)wechatLogin{
    SendAuthReq *req = [[SendAuthReq alloc] init];
    req.scope = @"snsapi_userinfo";
    [WXApi sendReq:req];
}

- (void)zplayLoginHandleOpenUrl:(id)platformMessage{
    if (platformMessage==nil) {
        return;
    }
    [WXApi handleOpenURL:[platformMessage objectForKey:@"url"] delegate:self];

}

- (void)zplayPlatformLogout{

}

//授权后回调 WXApiDelegate
-(void)onResp:(BaseReq *)resp
{
    /*
     ErrCode ERR_OK = 0(用户同意)
     ERR_AUTH_DENIED = -4（用户拒绝授权）
     ERR_USER_CANCEL = -2（用户取消）
     code    用户换取access_token的code，仅在ErrCode为0时有效
     state   第三方程序发送时用来标识其请求的唯一性的标志，由第三方程序调用sendReq时传入，由微信终端回传，state字符串长度不能超过1K
     lang    微信客户端当前语言
     country 微信用户当前国家信息
     */
    if ([resp isKindOfClass:[SendAuthResp class]]) {
        SendAuthResp *aresp = (SendAuthResp *)resp;
//        NSLog(@"微信code:%d",aresp.errCode);

        if (aresp.errCode== 0) {
            NSString *code = aresp.code;
            self.code = code;
            [self getWeChatUserAccess_token];
        }else{
            if (_isLogin) {
                [self platfomrFailed:ZplayPlatformLoginFailed];
            }
            else{
                [self platfomrFailed:ZplayPlatformConversionFailed];
                
            }
        }
    }
}

-(void)getWeChatUserAccess_token
{
    NSString *url =[NSString stringWithFormat:@"https://api.weixin.qq.com/sns/oauth2/access_token?appid=%@&secret=%@&code=%@&grant_type=authorization_code",self.weChtaAppId,self.weChtaSecert,self.code];
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        NSURL *zoneUrl = [NSURL URLWithString:url];
        NSString *zoneStr = [NSString stringWithContentsOfURL:zoneUrl encoding:NSUTF8StringEncoding error:nil];
        NSData *data = [zoneStr dataUsingEncoding:NSUTF8StringEncoding];
        dispatch_async(dispatch_get_main_queue(), ^{
            if (data) {
                NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:nil];
                self.access_token = [dic objectForKey:@"access_token"];
                self.openid = [dic objectForKey:@"openid"];
                NSLog(@"微信数据：%@",dic);
                [self getWeChatUserInfo];
            }
        });
    });
}


-(void)getWeChatUserInfo
{
    NSString *url =[NSString stringWithFormat:@"https://api.weixin.qq.com/sns/userinfo?access_token=%@&openid=%@",self.access_token,self.openid];
    dispatch_async(dispatch_get_global_queue(DISPATCH_QUEUE_PRIORITY_DEFAULT, 0), ^{
        NSURL *zoneUrl = [NSURL URLWithString:url];
        NSString *zoneStr = [NSString stringWithContentsOfURL:zoneUrl encoding:NSUTF8StringEncoding error:nil];
        NSData *data = [zoneStr dataUsingEncoding:NSUTF8StringEncoding];
        dispatch_async(dispatch_get_main_queue(), ^{
            if (data) {
                NSDictionary *dic = [NSJSONSerialization JSONObjectWithData:data options:NSJSONReadingMutableContainers error:nil];
                /*
                 {
                 city = "";
                 country = CN;
                 headimgurl = "http://wx.qlogo.cn/mmopen/ajNVdqHZLLBhJibS0090CZbnnCI8y6x511yiajGAg4jYd92jbIicTpib2ZDt0Ww6YhM2JKtWg3icGwRtJfbqSM4Em4w/0";
                 language = "zh_CN";
                 nickname = "\U8ffd\U68a6\U4eba";
                 openid = oNUeRwXJ3n56VULcuXBSawCx698k;
                 privilege =     (
                 );
                 province = Beijing;
                 sex = 1;
                 unionid = oKHJNuEjUR8kIrKN7IbIGKdDFLNs;
                 }
                 */
                //                UIImage *image = [UIImage imageWithData:[NSData dataWithContentsOfURL:[NSURL URLWithString:[dic objectForKey:@"headimgurl"]]]];
                
                NSString *nickname = [dic objectForKey:@"nickname"];
                NSString *headImageUrl = [dic objectForKey:@"headimgurl"];
                
                NSString *userHead = (NSString *)
                CFBridgingRelease(CFURLCreateStringByAddingPercentEscapes(kCFAllocatorDefault,
                                                                          (CFStringRef)headImageUrl,
                                                                          NULL,
                                                                          (CFStringRef)@"!*'();:@&=+$,/?%#[]",
                                                                          kCFStringEncodingUTF8));
              
                NSMutableDictionary *dict = [[NSMutableDictionary alloc]init];
                [dict setObject:self.openid==nil?@"":self.openid forKey:@"openid"];
                [dict setObject:self.access_token==nil?@"":self.access_token forKey:@"access_token"];
                [dict setObject:nickname==nil?@"":nickname forKey:@"nickname"];
                [dict setObject:userHead==nil?@"":userHead forKey:@"userHeadImage"];
                [dict setObject:[NSString stringWithFormat:@"%lu",(unsigned long)ZplayWeChatPlatform] forKey:@"platformType"];

                if (_isLogin) {
                    [self platfomrLoginSuccess:dict];
                }
                else{
                    [self platformBindSucces:dict];
                }
               
                NSLog(@"微信用户信息详情：%@",dic);
              
            }
        });
        
    });
}











@end
