//
//  ZplayLoginAdNetworkAdapter.h
//  TestFrameWork
//
//   Created by Castiel Chen  on 15/8/6.
//  Copyright (c) 2015年 ZplayLogin. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ZplayLoginAdNetworkAdapter.h"
#import "ZplayLoginNetworkRegistry.h"
#import "ZplatPlatformDelegate.h"

extern NSString *ZplayQQLoginAdapter;
extern NSString *ZplayWeChatLoginAdapter;
extern NSString *ZplayWeiboLoginAdapter;
extern NSString *ZplayFacebookLoginAdapter;

@class ZplayLoginCore;


@interface ZplayLoginAdNetworkAdapter : NSObject


@property(assign,nonatomic)ZplayLoginCore *core;



- (id)initWithZplayLoginAdapterWithProvider:(NSString *)provider
                                   Delegate:(id<ZplatPlatformDelegate>)delegate
                                  core:(id)core;

- (void)initializeLoginPlatforms;



/**
 登录
 */
- (void)zplayPlatformLoginWithMessage:(id)message;

/**
 绑定
 */
- (void)zplayPlatformBindWithMessage:(id)message;


/**
 邀请fb好友

 @param message
 */
- (void)zplayInviteUserFriendsWithMessage:(id)message;
/**
 退出
 */
- (void)zplayPlatformLogout;

/**
 系统回调通知
 
 */
- (void)zplayLoginHandleOpenUrl:(id)platformMessage;


/**
 登录成功
 */
- (void)platfomrLoginSuccess:(id)message;


/**
 绑定成功
 */
- (void)platformBindSucces:(id)message;


/**
 失败
 */
- (void)platfomrFailed:(ZplayPlatformFailed)errcode;


/**
 获取好友信息成功
 */
- (void)getFacebookUserFriendsSuccess:(id)message;

/**
 邀请好友
 */
- (void)inviteFacebookUserFriendsSuccess:(id)message;


/**
 *  开发者设置的ViewController
 *
 */
-(UIViewController*)viewControllerLoginModalView;


@end
