//
//  ZplayPlatformManager.h
//  Zplay_Demo
//
//  Created by Liubin on 2017/1/16.
//  Copyright © 2017年 ZPLAY. All rights reserved.
//

#import <UIKit/UIKit.h>
#import "ZplatPlatformDelegate.h"



@interface ZplayPlatformManager : NSObject

@property (nonatomic, assign)id<ZplatPlatformDelegate>delegate;


+(ZplayPlatformManager *)shareInstance;

/**
 初始化

 @param abroad YES为海外版，NO为使用国内版
 */
- (void)initWithAbroadPublish:(BOOL)abroad;


/**
 游客登录
 */
- (void)zplayVisitorLogin;

#pragma mark - Platform SDK API

/**
 设置代理

 @param zplayPlatformDelegate
 */
- (void)setZplayPlatformDelegate:(id<ZplatPlatformDelegate>)zplayPlatformDelegate;

/**
 登录
 
 @param viewController 当前控制器
 */
- (void)useLoginWithPlatform:(ZplayPlatformType)platform ViewController:(UIViewController *)viewController;

/**
 游客绑定qq账号
 
 @param viewController 当前控制器
 */
- (void)useConversionqqWithPlatform:(ZplayPlatformType)platform viewController:(UIViewController *)viewController;



/**
 IAP购买

 @param productID 商品计费点
 @param price 计费点对应价格
 @param gameOrderId 游戏支付订单号
 @param userInfo 用户数据，游戏客户端传入，可用于服务端验证，非必传
 @param cpInfo cp传入数据，透传参数
 */
- (void)zplayUseIAPWithProductId:(NSString *)productID
                           price:(NSString *)price
                     gameOrderId:(NSString *)gameOrderId
                  userInfoString:(NSString *)userInfo
                          cpInfo:(NSString *)cpInfo;



/**
  HandleOpenURL
 
 @param url
 @param options 可传nil
 */
- (void)useHandleOpenURL:(NSURL *)url options:(id)options;


/**
 退出
 */
- (void)useLogout;



#pragma mark - Other API
/**
 邀请用户好友

 @param fbLinkURL facebook APP Link URL
 */
- (void)inviteFacebookFriends:(NSString *)fbLinkURL;


//跳转社区主页
- (void)facebookLinkGameHomepageWithID:(NSString *)homepageID;


//获取当前设备地区是否为中国大陆
- (BOOL)currentDeviceAreaIsSetForChina;

//检测微信本地是否安装
- (BOOL)wxIsInstalled;

/**
 展示防沉迷界面
 */
- (void)showAntiAddictionView;


/**
 查询当前未成年玩家游戏收益状态
 */
- (void)queryCurrentGameJuvenilesPlayerStatus;


























@end
